<?php

namespace Service\Calendar\Precursor\Strategy;

use Service\Calendar\TaskCalendar;

class PrecursorFactory {

    CONST START_TO_START = 'II';
    CONST END_TO_END = 'TT';
    CONST START_TO_END = 'IT';
    CONST END_TO_START = 'TI';

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskRelationship $taskRelationship
     * @return null|EndToEnd|EndToStart|StartToEnd|StartToStart
     */
    public static function factory($taskRelationship, TaskCalendar $taskCalendar){
        $strategy = null;

        switch ($taskRelationship->getTypePrecursor()) {
            case self::START_TO_START :
                $strategy = new StartToStart($taskRelationship, $taskCalendar);
                break;
            case self::END_TO_END :
                $strategy = new EndToEnd($taskRelationship, $taskCalendar);
                break;
            case self::START_TO_END :
                $strategy = new StartToEnd($taskRelationship, $taskCalendar);
                break;
            default :
                $strategy = new EndToStart($taskRelationship, $taskCalendar);
                break;
        }
        return $strategy;
    }
} 